import { PropsWithChildren } from 'react'
import Taro, { useDidHide, useDidShow, useLaunch } from '@tarojs/taro'
import { globalApp } from '@/class/GlobalContext'
import {
    isEasyMode, createSessionId, formatQuery, formatDate
  } from '@/utils'
import useHotLaunch from '@/hooks/useHotLaunch'

import './app.less'

function App({ children }: PropsWithChildren<any>) {

    useLaunch(async (launch) => {
        globalApp()

        // // create session id
        // updateSession()

        // system info
        updateSystem()

        // updateGlobal(launch)

        // // network change
        // listeningConnectStatus()

        // // userinfo
        // await updateUserInfo()

        // mid
        // const mid = await requestMid()

        // Taro.$global.set('mid', mid)
        // Taro.setStorageSync('mid', mid)

        // getAccountInfoInApp()
    })

    // useHotLaunch((options) => {
    //     Taro.$global.set('subSessionid', createSessionId())

    //     const launchOption = Taro.$global.get('launchOption')
    //     Taro.$global.set('launchOption', {
    //         ...launchOption,
    //         hotScene: options.scene
    //     })

    //     reportShareVideo()
    // })

    useDidShow((options) => {
        // updateAbGroup()
        // reportUserActiveLog(options)
        // onEnvByShake()
    })

    useDidHide(() => {
        // offEnvByShake()

        Taro.$abGroupInstance
            .cleanLoop()
            .cleanStack()
    })
    useHotLaunch((options) => {
        Taro.$global.set('subSessionid', createSessionId())
    
        const launchOption = Taro.$global.get('launchOption')
        Taro.$global.set('launchOption', {
          ...launchOption,
          hotScene: options.scene
        })
    
        // reportShareVideo()
      })
    // children 是将要会渲染的页面
    return children
}

// system
function updateSystem() {
    const systemInfo = Taro.getSystemInfoSync()
  
    Taro.$global.set('systemInfo', {
      ...systemInfo,
      easyMode: isEasyMode(systemInfo) && 2 || 1// 关怀模式
    }) 
}

export default App
