import Taro from '@tarojs/taro'

class NetWork {
  #listenStack: Array<Function> = []
  networkType = 'none'

  constructor() {
    Taro.onNetworkStatusChange(res => {
      this.#listenStack.forEach(evt => evt(res))
    })

    this.getNetworkType().then((res: Taro.getNetworkType.SuccessCallbackResult) => {
      const { networkType } = res
      this.networkType = networkType
    })

    this.listen((res: Taro.onNetworkStatusChange.CallbackResult) => {
      const { networkType } = res
      this.networkType = networkType
    })

  }

  listen(evt) {
    if (typeof evt !== 'function')
      return

    this.#listenStack.push(evt)
  }

  getNetworkType() {
    return new Promise((success, fail) => {
      Taro.getNetworkType({
        success,
        fail
      })
    })
  }
}


export default new NetWork()