import Taro from '@tarojs/taro'
import { type, stringify } from '@/utils'

export default class Route {
  pageStacks
  page
  path

  constructor() {
    this.pageStacks = Taro.getCurrentPages() || []
    this.page = this.pageStacks[this.pageStacks.length - 1]
    this.path = this.page?.route || ''
  }

  push(obj) {
    if (obj == null)
      return
    
    if (type(obj, 'String')) {
      Taro.navigateTo({
        url: obj
      })
    } else if (type(obj, 'Object')) {
      const { url, query } = obj
      Taro.navigateTo({
        url: `${url}?${stringify(query)}`
      })
    }
  }
}
