import Taro from '@tarojs/taro'
import { View } from '@tarojs/components'
import { getTopSafeHeight } from '@/utils'
import './index.less'

type NavbarPropsType = {
  title?: string
  status?: boolean
  navigation?: boolean
  navigationColor?: string
  textColor?: string
}
function Navbar({title, status, navigation, textColor='', navigationColor=''}: NavbarPropsType) {
  const { navigationBarHeight, statusBarHeight} = getTopSafeHeight()

  function navigateBack() {
    Taro.navigateBack()
  }

  return (
    <View className='nav-bar' style={{ height: 'auto', width: '100vw'}}>
      {status && <View className='nav-bar-status' style={{ height: `${statusBarHeight}px`}}></View>}

      {navigation && <View className='nav-bar-navigation' style={{ height: `${navigationBarHeight}px`, color: textColor}}>
        <View className='back-icon' style={{borderColor: navigationColor}} onClick={navigateBack}></View>
        {title}
      </View>}
    </View>
  )
}

export default Navbar
