import Taro, { useLoad, useDidShow, useReady, useDidHide, usePullDownRefresh, useShareAppMessage, useRouter } from '@tarojs/taro'
import { useMemo, useState } from 'react'
import type CustomTabBar from '@/custom-tab-bar'
import { View, Swiper, SwiperItem, Video } from '@tarojs/components'
import { VideoInfo } from '@/constants/commentTypes'
import { videoListV2 } from '@/http/api'
// import { getTopSafeHeight, throttle, formatSecondsAsTime, getPreIds } from '@/utils'

// import Route from '@/class/Route'
import './index.less'

let pageNo = 1
let pending = false

export default function Index() {
    const page = useMemo(() => Taro.getCurrentInstance().page, []);
    const router = useRouter()
    const { params } = router || {}


    let state = {
        currentIdx: 0,
        currentSwiperIdex: 0,
    }
    const [videoList, setVideoList] = useState<VideoInfo[]>([])
    const [refresherTriggered, setRefresherTriggered] = useState(false)

    useLoad(() => {
        const { redirect } = params
        if (redirect) {
            // const route = new Route()
            // route.push(decodeURIComponent(redirect))
        }
        fecthVideoListV2()
    })

    useDidShow(() => {
        const tabbar = Taro.getTabBar<CustomTabBar>(page)
        tabbar?.setSelected(0)

    })

    useReady(() => {
        setVideoList([
            {
                id: 8987051,
                videoPath: 'http://rescdn.yishihui.com/longvideo/multitranscode/video/vpc/20210821/1244745QN8L8QWQjlbUmyQ5yI20210822131000216222495-3HD.mp4',
                title: '标题 1',
                shareTitle: '标题 1',
                coverImgPath: 'http://rescdn.yishihui.com/longvideo/snapshot/vpc/20210821/1244745QN8L8QWQjlbUmyQ5yI_0?x-oss-process=image/resize,m_fill,w_600,h_480,limit_0/format,jpg/watermark,image_eXNoL3BpYy93YXRlcm1hcmtlci9iZ195eS5wbmc_eC1vc3MtcHJvY2Vzcz1pbWFnZS9yZXNpemUsaF80OS9yZXNpemUsbV9maWxsLHdfMTg1LGhfNDksbGltaXRfMA==,g_nw,x_408,y_414/watermark,type_d3F5LW1pY3JvaGVp,size_31,text_NS405LiH5Lq655yL6L-H,color_FFFFFF,t_100,g_nw,x_420,y_423/watermark,image_eXNoL3BpYy93YXRlcm1hcmtlci9pY29uX3BsYXlfd2hpdGUucG5nP3gtb3NzLXByb2Nlc3M9aW1hZ2UvcmVzaXplLHdfMTQ0,g_center',
                recomTraceId: '',
                flowPool: '',
                user: {
                    uid: 6282380,
                    nickName: 'dax15818675906',
                    avatarUrl: 'http://rescdn.yishihui.com/longvideo/pic/vpc/20201219/1244745CJ2mPPZ3eXhsjjjf8t?x-oss-process=image/rotate,0/resize,m_fill,w_100,h_100,limit_0/format,jpg'
                }

            },
            {
                id: 9105322,
                videoPath: 'http://visionularcdn.yishihui.com/output/longvideo/multitranscode/video/vpc/20211112/12188054KWIADXkh5GTl8w2ijD20211114191000658534245-1LD.mp4',
                title: '生存法则',
                shareTitle: '生存法则',
                coverImgPath: 'http://rescdn.yishihui.com/longvideo/pic/62e7c34380754aeab87fc1386fb879d61631682451076?x-oss-process=image/resize,m_fill,w_600,h_480,limit_0/format,jpg/watermark,image_eXNoL3BpYy93YXRlcm1hcmtlci9iZ195eS5wbmc_eC1vc3MtcHJvY2Vzcz1pbWFnZS9yZXNpemUsaF80OS9yZXNpemUsbV9maWxsLHdfMTg1LGhfNDksbGltaXRfMA==,g_nw,x_408,y_414/watermark,type_d3F5LW1pY3JvaGVp,size_31,text_NS4y5LiH5Lq655yL6L-H,color_FFFFFF,t_100,g_nw,x_420,y_423/watermark,image_eXNoL3BpYy93YXRlcm1hcmtlci9pY29uX3BsYXlfd2hpdGUucG5nP3gtb3NzLXByb2Nlc3M9aW1hZ2UvcmVzaXplLHdfMTQ0,g_center',
                recomTraceId: '',
                flowPool: '',
                user: {
                    uid: 6282380,
                    nickName: '寰娱圈子',
                    avatarUrl: 'http://rescdn.yishihui.com/longvideo/pic/vpc/20210401/151084326SAWDfr35MbV13Yqjf?x-oss-process=image/quality,q_10'
                }

            }
        ])
    })

    useDidHide(() => {

    })

    usePullDownRefresh(() => {

    })

    useShareAppMessage(() => {
        return {
            title: '好友分享给你一个视频，点击查看～',
        }
    })

    // const fecthVideoList = throttle(fecthVideoListV2)
    function fecthVideoListV2(cleanOldCardList = false) {
        Taro.$http.post(videoListV2, {
            categoryId: 55,
            pageNo,
            pageSize: 6,
            pageSource: 'pages/category'
        }).then((res: RequestType) => {
            const { code, data } = res
            if (code != 0)
                return

            let oldCardList = videoList

            if (cleanOldCardList) {
                oldCardList = []
                setRefresherTriggered(false)
            }

            pageNo++

            setVideoList([
                ...oldCardList,
                ...filterCardProps(data)
            ])

        }).catch(() => {
            pending = false
        })
    }

    function pause() {
        console.log('hhz-')
    }

    // 视频卡片需要参数过滤重组一次，并不需要把所有的数据都传进去
    function filterCardProps(list) {
        return list.map((item: RoughCardType) => {
            const {
                title, coverImg, user, id, videoPath,
                recomTraceId, flowPool, shareTitle = ''
            } = item || {}
            const { coverImgPath = '' } = coverImg || {}
            const { avatarUrl = '', nickName = '', uid = 0 } = user || {}

            return {
                id,
                title,
                coverImgPath,
                shareTitle,
                videoPath,
                recomTraceId,
                flowPool,
                user:{
                    uid,
                    avatarUrl,
                    nickName,
                }
            }
        })
    }

    return (
        <View className='container'>
            <Swiper
                className="video_list"
                duration={300}
                circular
                vertical
            >
                {videoList.map(item => (
                    <SwiperItem key={item.id} className="banner_list__item">
                        <Video className='videoplayer'
                            src={item.videoPath}
                            loop
                            controls={false}
                            enableProgressGesture={false}
                            onTap={pause}
                        >

                        </Video>
                    </SwiperItem>
                ))}
            </Swiper>
        </View>
    )
}
